package diffcad;

import gui.Colorable;
import observers.ObservableInt;

import java.awt.*;


public final class Grid implements Colorable {
    private boolean visible = true;
    public ObservableInt width = new ObservableInt(20, "Grid width:");
    Color color;
    Color oldColor;

    public void draw(Graphics g) {
        if (visible)
            _draw(g);
    }

    public void setColor(Color c_) {
        color = c_;
    }

    public Color getColor() {
        return color;
    }

    private void _draw(Graphics g) {
        Rectangle r = g.getClipRect();

        int w = r.width;
        int h = r.height;

        int grid_spacing = width.getValue(); // mms
        oldColor = g.getColor();
        g.setColor(color);
        for (int x = r.x; x < w; x = x + grid_spacing) {
            g.drawLine(x, 0, x, h);
        }

        for (int y = r.y; y < h; y = y + grid_spacing) {
            g.drawLine(0, y, w, y);
        }
        g.setColor(oldColor);

    }


    public void toggleVisible() {
        visible = !visible;
    }

}