package grapher;

import futils.Futil;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.StreamTokenizer;
import java.net.URL;
import java.util.Vector;

/*
** class Markers
**              This class is used to load and store the marker definitions.
** The marker definitions are not compiled in but are loaded from a file.
*/

class Markers extends Object {

/*
**    Number of markers loaded
*/
    public int number = 0;
/*
**    An array of vectors. Each element in the array contains the vertex
**    vectors for a marker. Marker 1 is at element vert[0].
*/
    public Vector vert[] = new Vector[10];

/*
**    Markers(URL file)
**         The marker contructor. Loads the markers from the givern URL
*/
    public Markers(URL file) {

        //try {
        //      getMarkers(file);
        //}
        // catch ( FileFormat e ) {
        //   e.printStackTrace();
        // }
    }
/*
**   getMarkers(URL file)
**        This method read the marker file and loads the marker definitions
**   into the vert array. The format of the file is simple
**   The keword "start" starts a new marker definition.
**   The keword "end"   ends a marker definition.
**   m x y means move to position x,y
**   l x y means line to x,y from previous position.
*/
    private void getMarkers(URL file)
            throws IOException {
        InputStream is;
        StreamTokenizer st;
        MVertex v;

        // added  file  name, DL
        String file_string = Futil.getReadFileName();
        FileInputStream input_stream = new FileInputStream(file_string);
        // end of additions, DL

        try {
            System.out.println("Opening markers");
            is = input_stream; // DL strikes again..
            //file.openStream();
        } catch (Exception e) {
            return;
        }

        st = new StreamTokenizer(is);
        st.eolIsSignificant(true);
        st.commentChar('#');

        scan:
              while (true) {
                  switch (st.nextToken()) {
                      default:
                          break scan;
                      case StreamTokenizer.TT_EOL:
                          break;
                      case StreamTokenizer.TT_WORD:

                          if ("start".equals(st.sval)) {
                              vert[number] = new Vector();
                          } else if ("end".equals(st.sval)) {
                              number++;
                          } else if ("m".equals(st.sval)) {
                              v = new MVertex();
                              v.draw = false;
                              if (st.nextToken() == StreamTokenizer.TT_NUMBER) {
                                  v.x = (int) st.nval;
                                  if (st.nextToken() == StreamTokenizer.TT_NUMBER) {
                                      v.y = (int) st.nval;
                                      vert[number].addElement(v);
                                  }
                              }
                          } else if ("l".equals(st.sval)) {
                              v = new MVertex();
                              v.draw = true;
                              if (st.nextToken() == StreamTokenizer.TT_NUMBER) {
                                  v.x = (int) st.nval;
                                  if (st.nextToken() == StreamTokenizer.TT_NUMBER) {
                                      v.y = (int) st.nval;
                                      vert[number].addElement(v);
                                  }
                              }
                          }
                          break;
                  }


              }
        try {
            if (is != null)
                is.close();
        } catch (Exception e) {
        }
    }

}