package ipl;

import java.awt.*;
import java.awt.image.FilteredImageSource;
import java.awt.image.ImageProducer;

class ImageCanvas extends Canvas {
    Image flipImage;
    Image image;
    boolean flipH = true, flipV = true;
    FlipFilter imgf = new FlipFilter();

    ImageCanvas(Image image) {
        this.image = image;
        processImage();
    }

    public void paint(Graphics g) {
        g.drawImage(flipImage, 0, 0, this);
    }

    void processImage() {
        ImageProducer ip = image.getSource();

        imgf.setFlip(flipH, flipV);
        ip = new FilteredImageSource(ip, imgf);
        flipImage = getToolkit().createImage(ip);
        repaint();
    }

    public boolean mouseDown(Event evt, int x, int y) {
        if (flipH & flipV) {
            flipH = flipV = false;
        } else if (flipV) {
            flipH = true;
            flipV = false;
        } else {
            flipV = true;
        }
        processImage();
        return true;
    }
}
