package surfer;

/******************************************************************************************

 * Surface Plotter version 1.10                                               Oct 14 1996 *

 * Surface Plotter version 1.20                                               Nov  8 1996 *

 *                                                                                        *

 * PlusMinus.java: Plus-Minus buttons for InputField                                      *

 *                                                                                        *

 * Copyright (c) 1996 Yanto Suryono. All Rights Reserved.                                 *

 *                                                                                        *

 * Permission to use, copy, and distribute this software for NON-COMMERCIAL purposes      *

 * and without fee is hereby granted, provided that this copyright notice appears in all  *

 * copies and this software is not modified in any way                                    *

 *                                                                                        *

 * Please send bug reports and/or corrections/suggestions to                              *

 * Yanto Suryono <d0771@cranesv.egg.kushiro-ct.ac.jp>                                     *

 ******************************************************************************************/


import java.awt.*;

public class PlusMinus extends Panel {

    private InputField Parent;

    private Button increaseButton = new Button("+");
    private Button decreaseButton = new Button("-");

    private static int WIDTH = 15;


    PlusMinus(InputField parent) {

        super();

        setFont(new Font("Helvetica", Font.PLAIN, 9));

        setLayout(new GridLayout(2, 1));
        add(increaseButton);
        add(decreaseButton);
        Parent = parent;

    }


    public Dimension preferredSize() {

        return new Dimension(WIDTH, 0);

    }


    public boolean action(Event e, Object arg) {

        if (e.target == increaseButton) {
            Parent.Increase();
            return true;
        } else if (e.target == decreaseButton) {
            Parent.Decrease();
            return true;
        }

        return false;

    }

}



