package vs;

import java.awt.*;


class ScrollableImageCanvas extends Canvas {
    Image img;
    Scrollbar vs, hs;

    ScrollableImageCanvas(Image img, Scrollbar hs, Scrollbar vs) {
        this.img = img;
        this.hs = hs;
        this.vs = vs;
        repaint();
    }

    public void update(Graphics g) {
        paint(g);
    }

    public void paint(Graphics g) {
        // Calculate the displayed size of the image.
        int x = -(img.getWidth(this) - size().width) / hs.getMaximum()
                * hs.getValue();
        int y = -(img.getHeight(this) - size().height) / vs.getMaximum()
                * vs.getValue();

        // Dsiplay image
        g.drawImage(img, (x > 0)?0:x, (y > 0)?0:y, this);
    }
}
